# Extend boxDescription.tsv with additional label-specific data for use
# with glabels (https://glabels.org/)
# $Id$
BEGIN {
	httpHost = USE_HOST;

	displayBox = httpHost "/cgi-bin/displayBox?boxId=";

	defaultWeightColor = "black";
	defaultTypeColor = "black";

	weightColors["Light"] = "green";
	weightColors["Heavy"] = "blue";
	weightColors["VeryHeavy"] =  "magenta";
	weightColors["ExtremelyHeavy"] = "red";

	weightLabels["Light"] = "LIGHT";
	weightLabels["Heavy"] = "HEAVY";
	weightLabels["VeryHeavy"] =  "VERY HEAVY";
	weightLabels["ExtremelyHeavy"] = "EXTREMELY HEAVY";

	defaultTypeColor="#000000";
	typeColors["Books"] = "DarkGreen";
	typeColors["Nanoblocks"] = "Purple";
	typeColors["Models"] = "Purple";

}

{
	if (NR == 1) { # first line
		print $0 "\tweightColor\tweightLabel\tURL";
		for(i=1;i<=NF;i+=1) {
			fieldIndex[$i] = i;
		}
		descIndex = fieldIndex["Description"];
		next;
	}


	boxId = $(fieldIndex["BoxId"]);
	weight = $(fieldIndex["Weight"]);
	boxURL = displayBox boxId;

	if (weight in weightColors) {
		useWeightColor = weightColors[weight];
	} else {
		useWeightColor = defaultWeightColor;
	}
	if (weight in weightLabels) {
		useWeightLabel = weightLabels[weight];
	} else {
		useWeightLabel = weight;
	}
	for(i=1;i<=NF;i+=1) {
		if (i != 1) {
			printf("\t");
		}
		if (i == descIndex) {
#			gsub("'", "\\&lquote;", $(descIndex));
		}
		printf("%s", $(i));
	}
	print "\t" useWeightColor "\t" useWeightLabel "\t" boxURL;
}
