# Parse HTML form data; handles both urlencoded and multipart/form-data
# Author: Geoff Carpenter - http://www.fargos.net/gcc.html

BEGIN {
	BINMODE=3; # GNU awk enables binary file mode for both input and output
	for(i=0;i<=9;i+=1) {
		c = sprintf("%c", i + 48); # 48='0'
		hexToInt[c] = i;
	}
	for(i=10;i<=15;i+=1) {
		c = sprintf("%c", i - 10 + 65); # 65='A'
		hexToInt[c] = i;
		c = sprintf("%c", i - 10 + 97); # 97='a'
	}
	parseMode = 0;
	found = 0;
	binaryMode = 0;
}

function decodeURIval(encodedVal, result, _i, _c, _l, _n)
{
	_l = length(encodedVal);
	result = "";
	for(_i=1;_i<=_l;_i+=1) {
		_c = substr(encodedVal, _i, 1);
		if (_c == "%") {
			_n = 16 * hexToInt[substr(encodedVal, _i + 1, 1)];
			_n += hexToInt[substr(encodedVal, _i + 2, 1)];
			_c = sprintf("%c", _n);
			if (_c != "\r") {
				if ((_c == "\n") && (ESCAPE_NEWLINE == 1)) {
					result = result "\\n";
				} else if ((_c == "\"") && (ESCAPE_QUOTE == 1)) {
					result = result "\\\"";
				} else {
					result = result _c;
				}
			}
			_i += 2;
		} else if (_c == "+") {
			result = result " ";
		} else {
			if ((_c == "\n") && (ESCAPE_NEWLINE == 1)) {
				result = result "\\n";
			} else if ((_c == "\"") && (ESCAPE_QUOTE == 1)) {
				result = result "\\\"";
			} else {
				result = result _c;
			}
		}
	}
	return (result);
}

{
	l = length($0);
	if (binaryMode == 0) {
		if (substr($0, l) == "\r") { # drop carriage return
			$0 = substr($0, 1, l - 1);
			l = l - 1;
		}
	}
#print parseMode ":" l ":" binaryMode ": " $0 >> "/tmp/tmp.form.log";
	if (NR == 1) {
		if (substr($0, 1, 5) == "-----") {
			parseMode = 2;
			parseSeparator = $0;
			separatorLen = l;
#print "saw Separator l=" separatorLen >> "/tmp/tmp.form.log";
		} else {
			parseMode = 1;
		}
	}
	if (parseMode == 1) {
		for(i=1;i<=NF;i+=1) {
			equals = index($i, "=");
			key = substr($i, 1, equals - 1);
			if (key == WANT) {
				encodedVal = substr($i, equals + 1);
				val = decodeURIval(encodedVal);
				printf("%s", val); # output result
				found = 1;
				break;
			}
		}
		exit;
	}
	if (parseMode == 2) {
		if ($0 == parseSeparator) {
			parseMode = 3; # parse headers
			contentBody = "";
			binaryMode = 0;
		}
		next;
	}
	if (parseMode == 3) {
		if ((l == 0) || ($0 == "\r")) {
#print "shift to parsemode4" >> "/tmp/tmp.form.log";
			parseMode = 4;
			next;
		}
#print "$1=" $1 >> "/tmp/tmp.form.log";
		if ($1 == "Content-Disposition:") {
			i = index($3, "=");
			l1 = length($3);
			lastChar = substr($3, l1, 1);
			if (lastChar == ";") { # drop trailing semicolon
				l1 -= 1;
			}
			# skip past = and quote mark, drop tailing quote
			fieldName = substr($3, i + 2, l1 - (i + 2));
#print "fieldName=" fieldName " l1=" l1 " WANT=" WANT >> "/tmp/tmp.form.log";
		} else if ($1 == "Content-Type:") {
#print " WANT_TYPE=" WANT_TYPE " last=" $NF >> "/tmp/tmp.form.log";
			if (WANT_TYPE == 1) {
#print " FOUND WANT_TYPE=" WANT_TYPE " last=" $NF >> "/tmp/tmp.form.log";
				print $NF;
				found = 1;
				exit;
			}
			binaryMode = 1;
#print " BINARY MODE" >> "/tmp/tmp.form.log";
		}
	}
	if (parseMode == 4) {
		if ((l >= separatorLen) &&
		   (substr($0,1,separatorLen) == parseSeparator)) {
#print "FIELD_NAME=" fieldName " CONTENT=" contentBody >> "/tmp/tmp.form.log";
			if (fieldName == WANT) {
#print "WANTED FIELD_NAME=" fieldName " CONTENT=" contentBody >> "/tmp/tmp.form.log";
				if (binaryMode == 0) {
					val = decodeURIval(contentBody);
					printf("%s\n", val); # output result
				} else {
					l1 = length(contentBody);
					lastChar = substr(contentBody, l1, 1);
					# drop tailing CR/LF (LF was never added)
					if (lastChar == "\r") {
						contentBody = substr(contentBody, 1, l1 - 1);
					}
					printf("%s", contentBody);
				}
				found = 1;
			}
			parseMode = 3;
			contentBody = "";
			binaryMode = 0;
			next;
		}
		if (contentBody == "") {
			contentBody = $0;
		} else {
			contentBody = contentBody "\n" $0;
		}
	}
}

END {
	fflush(stdout);
	if (found == 0) {
		printf "KEY " WANT " NOT FOUND\n" > "/dev/stderr";
	}
}
